###############################
### FREE GIRLS INTERACTIONS ###
###############################

label free_girl_interact(girl):
    
    
    $ renpy.block_rollback()
    $ loc_pic = selected_location.get_pic(config.screen_width, int(config.screen_height*0.8))
    
    if MC.interactions > 0:
        
        if MC.get_effect("special", "notebook"):
            $ choice_menu_girl_interact = True
        
        $ city_label = girl.init_dict["background story/city_label"]
        
        if city_label:
            if renpy.has_label(city_label): # Problem: Game will still crash if the label doesn't allow for the girl argument
                call expression city_label pass (girl=girl) from _call_expression_4
            else:
                "System" "Label: {color=[c_red]}[city_label]{/color} doesn't exist (Custom girl: {color=[c_red]}[girl.path]{/color})."

        else:
            call free_girl_talk(girl) from _call_free_girl_talk
    
    else:
        "You do not have any interactions left for today."
    $ choice_menu_girl_interact = False
    
    hide screen dark_filter
    hide screen show_event
    hide screen free_girl_interact
    show screen visit_location()
    with dissolve

    return

label free_girl_talk(girl):
        
    if not girl.MC_interact:
        
        hide screen visit_location
        show screen show_event(girl.profile, x=config.screen_width, y=int(config.screen_height*0.8), bg=loc_pic)
        with fade

        $ choice_menu_girl_interact = False

        ## Greetings

        $ MC.interactions -= 1
        
#        if girl.get_dialogue("free_girl_introduction"):
#            call dialogue(girl, "free_girl_introduction")
        
#        else:
        $ text1 = rand_choice(("As you walk around the %s, ", "On your way to %s, ", "Strolling around the %s absentmindedly, ")) % selected_location.name

        $ text1 += rand_choice(("you notice a pretty girl standing by herself.", " you nearly bump into a cute young woman.", " you spot a pretty little thing haggling with a peddler.", " you see a beautiful girl, looking lost."))

        "[text1]"

        menu:

            extend ""

            "Greetings":

                $ renpy.block_rollback()

                you "Greetings, my lady. They call me [MC.name], your humble servant. Is there anything I can do to help?"
                
#                call dialogue(girl, "free_girl_greetings_polite")
                
                if girl.personality.name in ("superficial", "rebel", "sweet"):

                    girl.char "My, I didn't expect to meet a true gentleman here! *laugh* I'm [girl.fullname]. Nice to meet you."

                    $ girl.change_love(2)

                elif girl.personality.name in ("cold", "masochist"):

                    girl.char "...{w=1} I'm [girl.fullname]. I don't need help."


                else:

                    girl.char "Uh? You don't have to be so formal... My name is [girl.fullname]." 

                    $ girl.change_love(1)



            "Hi there":

                $ renpy.block_rollback()

                you "Oh, hi there! I'm [MC.name]. Who are you?"

                if girl.personality.name in ("meek", "nerd", "cold"):

                    girl.char "Oh, hi. I'm [girl.fullname]."

                    $ girl.change_love(2)

                elif girl.personality.name in ("superficial", "pervert"):

                    girl.char "What are you thinking, coming to me like that? Couldn't you think of something more original?"
                    girl.char "My name is [girl.fullname]. Now get lost."

                else:

                    girl.char "You're the direct type, aren't you... I'm [girl.fullname]."

                    $ girl.change_love(1)


            "Hey, sexy":

                $ renpy.block_rollback()

                if dice(6) < 6:

                    you "Well, what do we have here... Damn, you're hot! I'm [MC.name]. What's your name baby?"
                else:
                    $ text1 = rand_choice(("Is your dad a Baker? 'cause you've got some nice buns!", "I'm not staring at your boobs. I'm staring at your heart.", "Did we take a class together? I could've sworn we had chemistry."))

                    you "[text1]"

                if girl.personality.name in ("pervert", "masochist"):

                    girl.char "Ah, a man who knows what he wants... *smile* My name is [girl.fullname]. Nice meeting you."

                    $ girl.change_love(2)

                elif girl.personality.name in ("superficial", "cold"):

                    girl.char "Oh, hi. I'm [girl.fullname]."

                    $ girl.change_love(1)

                else:
                    girl.char "How dare you! Hmpf. My name is [girl.fullname], and I don't like your manners!"

        $ girl.meet_MC()
        
        return

    elif girl.get_love() >= 25 and girl.MC_relationship_level == 0:
        hide screen visit_location
#        show screen dark_filter
        show screen show_event(girl.profile, x=config.screen_width, y=int(config.screen_height*0.8), bg=loc_pic)
        with fade

        call free_girl_friend(girl) from _call_free_girl_friend

    elif girl.get_love() >= 50 and girl.MC_relationship_level == 1:
        hide screen visit_location
#        show screen dark_filter
        show screen show_event(girl.profile, x=config.screen_width, y=int(config.screen_height*0.8), bg=loc_pic)
        with fade

        call free_girl_love_interest(girl) from _call_free_girl_love_interest

    elif girl.get_love() >= 75 and girl.MC_relationship_level == 3:
        hide screen visit_location
#        show screen dark_filter
        show screen show_event(girl.profile, x=config.screen_width, y=int(config.screen_height*0.8), bg=loc_pic)
        with fade

        call free_girl_girlfriend(girl) from _call_free_girl_girlfriend
        
    elif girl.get_love() >= 90 and girl.MC_relationship_level == 4:
        hide screen visit_location
#        show screen dark_filter
        show screen show_event(girl.profile, x=config.screen_width, y=int(config.screen_height*0.8), bg=loc_pic)
        with fade

        call free_girl_job_request(girl) from _call_free_girl_job_request
    
    else:
        call free_girl_interact_menu() from _call_free_girl_interact_menu
        return
    
    hide screen dark_filter
    hide screen show_event
    with fade
    
# Main interaction menu

label free_girl_interact_menu():

    ## Cannot go above a certain love level if girl doesn't have the right relationship level

    $ limit = {0 : 25, 1 : 50, 2 : 50, 3 : 75, 4 : 100, 5 : 100}

    if girl.love > limit[girl.MC_relationship_level]:
        $ girl.love = limit[girl.MC_relationship_level]
    
    hide screen visit_location
    show screen free_girl_interact(girl)
    with dissolve
        
    $ topic = ui.interact()
        
    if topic == "back":
        pass
    
    elif isinstance(topic, GirlInteractionTopic):
        $ last_free_interact_menu = topic.type
        
        show screen dark_filter
        with Dissolve(0.1)
        
#        hide screen free_girl_interact
        
        call free_try_interact(girl, topic.group) from _call_free_try_interact
        
        if isinstance(topic, GirlInteractionTopic): # This is because in rare cases (cheats), the UI may fail during the first call
            $ renpy.call(topic.label, girl)
        
        hide screen dark_filter
        hide screen show_event
        
        $ renpy.block_rollback()
            
        if MC.interactions >= 1:
            jump free_girl_interact_menu
            
    else:
        jump free_girl_interact_menu
    
    with Dissolve(0.1)
    
    return
    
label free_chat_small_talk(girl):

    $ girl.personality_unlock["EI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves


    $ text1 = rand_choice(("The weather's nice today, don't you think?", "I've heard it might rain later today...", "Last time I came here it was a lot more crowded.", "How have you been? Haven't seen you in a while.", "I saw you standing there, so well, uh... Thought I'd just talk to you.", "Don't you think this place is strange?", "This dog looks strange, doesn't it?"))

    you "[text1]"

    if girl.personality.name in ("pervert", "rebel"):

        girl.char "*yawn* Come on, this is boring."

    elif girl.personality.name in ("meek", "masochist"):

        girl.char "Oh, you're right, haha..."

        $ girl.change_love(2, cap=25)

    else:

        girl.char "Well, yeah, sure..."

        $ girl.change_love(1, cap=25)

    return
    
label free_chat_gossip(girl):

    $ girl.personality_unlock["EI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    if girl.personality.name in ("nerd", "sweet"):

        girl.char "Well, I don't really care about gossip, you know."

    else:

        if girl.personality.name in ("superficial", "rebel"):

            girl.char "Haven't you heard? oh, I've got some juicy gossip for you!"

            $ girl.change_love(2, cap=25)

        else:

            girl.char "I've heard some interesting news..."

            $ girl.change_love(1, cap=25)


        $ text1 = get_gossip()

        girl.char "[text1]"
    return
    
label free_chat_life(girl):

    $ girl.personality_unlock["MI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    you "What do you think about life, the universe, and everything?"

    if girl.personality.name in ("superficial", "meek"):

        girl.char "Oh, I don't know. What kind of question is that, anyway?"

    elif girl.personality.name in ("cold", "nerd"):

        girl.char "Interesting question! Well, here's a theory I came up with..."

        $ girl.change_love(2, cap=25)

    else:

        girl.char "That's a difficult question. I guess I should think about it more..."

        $ girl.change_love(1, cap=25)
    return
    
label free_chat_love(girl):

    $ girl.personality_unlock["MI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    you "Love. What do you think about it?"

    if girl.personality.name in ("cold", "masochist"):

        girl.char "Not much. I don't believe in love."

    elif girl.personality.name in ("pervert", "sweet"):

        girl.char "I'm waiting for my knight in shining armor, of course... *giggle*"

        $ girl.change_love(2, cap=25)

    else:

        girl.char "Well, everyone needs to find their match. Maybe I will, someday?"

        $ girl.change_love(1, cap=25)
    return

label free_chat_origins(girl):

    you "Where are you from?"

    girl.char "I come from [girl.origin]."

    $ girl.personality_unlock["origin"] = True

    $ girl.change_love(1, cap=40)
    return
    
label free_chat_hobbies(girl):

    you "What do you like to do with your free time?"

    $ h = girl.hobbies[dice(2)-1]

    girl.char "I really like [h]."

    $ girl.personality_unlock["hobby_" + h] = True

    $ girl.change_love(1, cap=40)
    return
    
label free_chat_likes(girl):

    $ thing, best = girl.talk_tastes("likes")

    you "What are your favorite things?"

    girl.char "My favorite [thing] is [best]. I love it!"

    $ girl.personality_unlock["fav_" + thing] = True
    $ girl.change_love(1, cap=40)
    return
    
label free_chat_dislikes(girl):

    $ thing, worst = girl.talk_tastes("dislikes")

    you "Is there anything you dislike?"

    girl.char "One [thing] I really don't like is [worst]. Ew!"

    $ girl.personality_unlock["dis_" + thing] = True
    $ girl.change_love(1, cap=40)
    return



label free_joke_harmless(girl):

    $ girl.personality_unlock["LR"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    $ joke = rand_choice(jokes["harmless"])

    you "[joke]"


    if girl.personality.name in ("nerd", "masochist"):

        girl.char "... Is that the best you can do?"

        $ girl.change_love(-1)

    elif girl.personality.name in ("meek", "sweet"):

        girl.char "Teeheehee! That was fun!"

        $ girl.change_love(3, cap=50)

    else:

        girl.char "Not bad, not bad..."

        $ girl.change_love(1, cap=50)
    return
    
label free_joke_adult(girl):

    $ girl.personality_unlock["LR"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    $ joke = rand_choice(jokes["sex"])

    you "[joke]"

    if girl.personality.name in ("cold", "sweet"):

        girl.char "I don't like it. You're making me uncomfortable."

        $ girl.change_love(-1)

    elif girl.personality.name in ("pervert", "rebel"):

        girl.char "Oh, you're naughty... *giggle*"

        $ girl.change_love(3, cap=50)

    else:

        girl.char "Not bad, not bad..."

        $ girl.change_love(1, cap=50)
    return
    
label free_joke_dark(girl):

    $ girl.personality_unlock["EI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    $ joke = rand_choice(jokes["dark"])

    you "[joke]"

    if girl.personality.name in ("superficial", "pervert"):

        girl.char "Wow, that was dark... Lighten up, will you! *frown*"

        $ girl.change_love(-1, cap=50)

    elif girl.personality.name in ("nerd", "cold"):

        girl.char "Muhahahaha! I love this kind of jokes."

        $ girl.change_love(3, cap=50)

    else:

        girl.char "Not bad, not bad..."

        $ girl.change_love(1, cap=50)
    return
    
label free_joke_mean(girl):

    $ girl.personality_unlock["MI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    $ joke = rand_choice(jokes["mean"])

    you "[joke]"

    if girl.personality.name in ("meek", "rebel"):

        girl.char "What the... Stop it! *mad*"

        $ girl.change_love(-1)

    elif girl.personality.name in ("superficial", "masochist"):

        girl.char "Aw, you're awful... *giggle*"

        $ girl.change_love(3, cap=50)

    else:

        girl.char "Not bad, not bad..."

        $ girl.change_love(1, cap=50)
    return


label free_touch_hand(girl):

    $ girl.personality_unlock["EI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    "You lightly grab her hand, brushing your fingers against her skin."

    if girl.personality.name in ("pervert", "cold"):

        girl.char "Hey, let go of my hand. This is awkward."

        $ girl.change_love(-1)

    elif girl.personality.name in ("sweet", "meek", "superficial"):

        girl.char "That feels... Nice..."

        $ girl.change_love(3, cap=90)

    else:

        girl.char "This is romantic..."

        $ girl.change_love(2, cap=90)
    return
    
label free_touch_kiss(girl):

    $ girl.personality_unlock["MI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    "Bringing your face closer, you lean in to kiss her."

    if girl.personality.name in ("pervert", "masochist"):

        "She pushes you away."

        girl.char "Are you trying to be romantic all of a sudden? You're being weird."

        $ girl.change_love(-1)

    elif girl.personality.name in ("sweet", "meek", "nerd"):

        "Your tongues intermingle as she kisses you back with passion."

        girl.char "Mmmh... Aaah..."

        $ girl.change_love(3, cap=90)

    else:

        "She gives you a light kiss."

        girl.char "There there..."

        $ girl.change_love(2, cap=90)
    return
    
label free_touch_ass(girl):

    $ girl.personality_unlock["DS"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    play sound s_surprise
    "*smack*" with vpunch

    if girl.personality.name in ("rebel", "superficial"):

        girl.char "Hands off! You pervert!"

        $ girl.change_love(-1)

    elif girl.personality.name in ("nerd", "cold", "masochist"):

        girl.char "Ah! Mmh... *blush*"

        $ girl.change_love(3, cap=90)

    else:

        girl.char "Hey! Control yourself! *giggle*"

        $ girl.change_love(2, cap=90)
    return
    
label free_touch_breasts(girl):

    $ girl.personality_unlock["LR"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    "You brush your hands against her tits, lightly touching her nipples."

    if girl.personality.name in ("nerd", "cold"):

        girl.char "What are you doing? Stop."

        $ girl.change_love(-1)

    elif girl.personality.name in ("rebel", "pervert", "superficial"):

        girl.char "Mmmh... That feels good... *blush*"

        $ girl.change_love(3, cap=90)

    else:

        girl.char "Oh..."

        $ girl.change_love(2, cap=90)
    return

label free_touch_pussy(girl):

    $ girl.personality_unlock["LR"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    "Pressing her body close, you lower your hand between her thighs."

    if girl.personality.name in ("meek", "sweet"):

        girl.char "No! Don't touch me there!"

        $ girl.change_love(-1)

    elif girl.personality.name in ("masochist", "pervert", "rebel"):

        girl.char "Oh!! Mmm... Oh yes, keep... doing that... *blush*"

        $ girl.change_love(3, cap=90)

    else:

        girl.char "Aah!"

        $ girl.change_love(2, cap=90)
    return
    
    
    
    
label free_play(girl):
    $ act = topic.act
    
    if act == "naked":

        $ girl.personality_unlock["EI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

        $ text1 =  "Why don't you strip down for me babe?"

        $ snd = s_equip_dress

        $ pic = girl.get_pic("naked", "profile", not_tags=all_farm_tags, soft=True)

    elif act == "service":
        
        $ girl.personality_unlock["DS"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

        $ diff = 76

        $ snd = "sucking.wav"

        $ pic = girl.get_pic("service", "naked", "profile", not_tags = ["group", "bisexual", "beast", "monster", "machine"])

        if pic.has_tag("mast"):
            $ text1 = "I want you to masturbate for me."
        elif pic.has_tag("titjob"):
            $ text1 = "I want to fuck those nice tits of yours."
        elif pic.has_tag("footjob"):
            $ text1 = "Why don't you jerk me off with your feet?"
        elif pic.has_tag("oral"):
            $ text1 = "I want you to suck my dick."
        elif pic.has_tag("handjob"):
            $ text1 = "I want you to jerk me off."
        else:
            $ text1 = "I want you to pleasure me."


        $ dislikes = ("rebel", "nerd")


    elif act == "sex":

        $ girl.personality_unlock["MI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

        $ diff = 78

        $ text1 = "Let me have you..."

        $ snd = "orgasm.wav"

        $ pic = girl.get_pic("sex", "naked", "profile", not_tags = ["group", "bisexual", "beast", "monster", "machine"])

        $ likes = ("nerd", "sweet")

        $ dislikes = ("masochist", "cold")


    elif act == "anal":

        $ girl.personality_unlock["LR"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

        $ diff = 80

        $ text1 = "I want to fuck your ass."

        $ snd = "orgasm2.mp3"

        $ pic = girl.get_pic("anal", "sex", "naked", "profile", not_tags = ["group", "bisexual", "beast", "monster", "machine"])

        $ likes = ("masochist", "rebel")

        $ dislikes = ("sweet", "superficial")


    elif act == "fetish":

        $ girl.personality_unlock["DS"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

        $ diff = 82

        $ text1 = "Bend over and get ready for a good whack."

        $ snd = "screams.wav"

        $ pic = girl.get_pic("fetish", "service", "naked", "profile", not_tags = ["group", "bisexual", "beast", "monster"])

        $ likes = ("masochist", "cold")

        $ dislikes = ("sweet", "meek")

    "Taking her by the hand, you lead her around a corner."

    you "Come here... [text1]"

    $ pref = girl.get_preference(act, bonus=girl.get_love() + MC.get_charisma()*10)

    if pref == "refuses":

        girl.char "No way! Get lost!!!"

        $ girl.raise_preference(act, bonus=0.5)
        $ girl.change_love(-1)

    else:

        if pref == "very reluctant":
            play sound s_sigh
            girl.char "I will do it, for you... But it's not something I enjoy at all..."
            $ girl.change_love(1)
        elif pref in ("reluctant", "a little reluctant"):
            play sound s_sigh
            girl.char "Pff... Okay, if that's what you {i}really{/i} want to do..."
            $ girl.change_love(2)
        elif pref == "indifferent":
            girl.char "Mmmh... Okay..."
            $ girl.change_love(3)
        elif pref in ("interested", "a little interested"):
            play sound s_mmmh
            girl.char "Mmmh... Why not... I feel horny already..."
            $ girl.change_love(4)
        elif pref == "fascinated":
            play sound s_mmmh
            girl.char "Oh, yes... I'm so wet thinking about it already..."
            $ girl.change_love(5)

        $ girl.raise_preference(act, "love", 1)

        $ MC.prestige += girl.rank

        show screen show_sex_event(pic, bg=loc_pic)
        with fade

        play sound snd

        girl.char "Mmmh... Aaah..."

        if not act == "naked":

            you "Ooooh..."

            with flash

        if act == "sex":
            if girl.pop_virginity(origin="MC"):
                $ girl.change_love(3)
                girl.char "You... You were my first..."
                "You have taken [girl.name]'s virginity... You earn extra prestige."
                $ MC.prestige += 3 * girl.rank

        hide screen show_sex_event
        with fade

        stop sound fadeout 3.0
        
        $ girl.test_weakness(act, unlock=True, feedback=True)
        
        if compare_preference(girl, act, "a little interested", bonus=girl.get_love() + MC.get_charisma()*10):
            girl.char "I liked that... *blush*"
        else:
            girl.char "Well... Are you satisfied now?"
    
    return
    
label free_flirt_beauty(girl):

    $ girl.personality_unlock["EI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    $ compliment = rand_choice(compliments["beauty"]) % girl.name

    you "[compliment]"

    if girl.personality.name == "masochist":

        girl.char "..."

        $ girl.change_love(-1)

    elif girl.personality.name == "rebel":

        girl.char "Hmmpf, do you think your weak compliments will get you into my pants?"

        $ girl.change_love(-1)

    elif girl.personality.name in ("superficial", "sweet"):

        girl.char "My, what a lovely thing to say!"

        $ girl.change_love(2, cap=75)

    else:

        girl.char "Why, thank you."

        $ girl.change_love(1, cap=75)
    return
    
label free_flirt_body(girl):

    $ girl.personality_unlock["LR"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    $ compliment = rand_choice(compliments["body"])

    you "[compliment]"

    if girl.personality.name == "masochist":

        girl.char "..."

        $ girl.change_love(-1)

    elif girl.personality.name in ("nerd", "sweet"):

        girl.char "Shut up! Who wants to hear lewd comments like that! *mad*"

        $ girl.change_love(-1)

    elif girl.personality.name in ("pervert", "meek", "superficial"):

        girl.char "You really think so? Mmh..."

        $ girl.change_love(2, cap=75)

    else:

        girl.char "Haha! *smile*"

        $ girl.change_love(1, cap=75)
    return

label free_flirt_mind(girl):

    $ girl.personality_unlock["MI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    $ compliment = rand_choice(compliments["mind"])

    you "[compliment]"

    if girl.personality.name == "masochist":

        girl.char "..."

        $ girl.change_love(-1)

    elif girl.personality.name in ("pervert", "superficial"):

        girl.char "Yeah right, heard this tired line a thousand time... *bored*"

        $ girl.change_love(-1)

    elif girl.personality.name in ("sweet", "nerd", "cold"):

        girl.char "Finally, someone who cares about my brains, not just my looks!"

        $ girl.change_love(2, cap=75)

    else:

        girl.char "Hey, you are turning out to be quite the gentleman today..."

        $ girl.change_love(1, cap=75)
        return
    
label free_flirt_spirit(girl):

    $ girl.personality_unlock["DS"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    $ compliment = rand_choice(compliments["spirit"])

    you "[compliment]"

    if girl.personality.name == "masochist":

        girl.char "..."

        $ girl.change_love(-1)

    elif girl.personality.name == "meek":

        girl.char "You... You're making fun of me. You're mean... *tearful*"

        $ girl.change_love(-1)

    elif girl.personality.name in ("sweet", "rebel"):

        girl.char "Hey, that's sweet! I feel like I'm lowering my guard around you..."

        $ girl.change_love(2, cap=75)

    else:

        girl.char "Well, thanks!"

        $ girl.change_love(1, cap=75)
    return
        
    
label free_flirt_sex_experience(girl):
    $ MC.rand_say(("Are you 'experienced'?", "Tell me the truth: have you been with many men before?", "Are you used to fool around with boys much?", "Did you know many men before me?", "ev: Have you been passed around the harbor like a bag of spice?", "ne: Be honest: Have you had a lot of sex before?", "gd: Are you skilled in the art of love?"))

    if girl.sexual_experience == "very experienced":
        play sound s_laugh
        "She laughs."
        girl.char "Oh, dear! If only you knew... I've done everything, and worse!"
        $ girl.change_love(3)
    elif girl.sexual_experience == "experienced":
        "She sticks her tongue out."
        girl.char "Well, I've been around, you know... *wink*"
        $ girl.change_love(2)
    elif girl.sexual_experience == "average":
        play sound s_sigh
        "She blushes."
        girl.char "That's a bit personal... But of course, I have not been waiting for you my whole life, you know?"
        $ girl.change_love(1)
    elif girl.sexual_experience == "inexperienced":
        play sound s_surprise
        "She blushes bright red."
        girl.char "Hey, it's not like that! I have had boyfriends, but you know... Nothing really serious."
    elif girl.sexual_experience == "very inexperienced":
        "She gives you an innocent look."
        girl.char "I'm not really sure what you mean by that? You don't mean..."
        "She frowns."
        $ girl.change_love(-1)

    if girl.has_trait("Virgin"):
        if girl.is_("lewd"):
            girl.char "But I've never... {i}done it{/i} with a man before, you know. I'm curious to know how it feels... *blush*"
        else:
            girl.char "I'm not a slut, you know! I've never... I mean, I'm waiting for the right person."

    $ girl.personality_unlock["LR"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    girl.char "What about you? Have you known many girls?"

    menu:
        "What do you tell her?"

        "I'm waiting for the right person":
            $ renpy.block_rollback()
            you "It might sound silly, but I am waiting for the right person..."

            # Will she believe you?

            $ res = MC.get_charisma() + dice(6)

            if MC.get_alignment() == "good":
                $ res += 1
            elif MC.get_alignment() == "evil":
                $ res -= 1

            if res >= 10:
                if girl.is_(("repressed", "idealist")):
                    girl.char "Really? Oh, darling, we're like soulmates..."
                    $ girl.change_love(5)
                elif girl.is_(("repressed", "materialist")):
                    girl.char "Really? Could it be that you're not so popular with girls, then? Well, at least you're mine..."
                    $ girl.change_love(2)
                elif girl.is_(("lewd", "idealist")):
                    girl.char "Oh, really? It doesn't hurt to have a little fun, you know... I'm excited that I can show you someday... *wink*"
                    $ girl.change_love(2)
                elif girl.is_(("lewd", "materialist")):
                    girl.char "Oh! Boooooring!"
            else:
                if girl.is_("repressed"):
                    girl.char "You expect me to believe that? You must really think I'm dumb..."
                    $ girl.change_love(-1)
                else:
                    girl.char "Tss, I don't believe you! *wink*"


        "I haven't been with many girls":
            $ renpy.block_rollback()
            you "Uh, well, no, not many..."

            # Will she believe you?

            $ res = MC.get_charisma() + dice(6)

            if MC.get_alignment() == "good":
                $ res += 1
            elif MC.get_alignment() == "evil":
                $ res -= 1

            if res >= 7:
                if girl.is_(("repressed", "idealist")):
                    girl.char "Aw... I wanted to be your only girl... But I will make you happy!"
                    $ girl.change_love(2)
                elif girl.is_(("repressed", "materialist")):
                    girl.char "Oh. I suppose it's normal, you're a man, after all..."
                    $ girl.change_love(2)
                else:
                    girl.char "Well, at least you're not entirely useless then! *wink*"
                    $ girl.change_love(1)
            else:
                if girl.is_("repressed"):
                    girl.char "You expect me to believe that? You must really think I'm dumb..."
                    $ girl.change_love(-1)
                else:
                    "She sticks her tongue out."
                    girl.char "Just a few, uh? A few dozens, perhaps? *wink*"


        "I've been around":
            $ renpy.block_rollback()
            you "Well, I've been around... You know."

            if girl.is_("very repressed"):
                girl.char "Well, no, I don't, actually."
            elif girl.is_("repressed"):
                girl.char "Oh..."
                $ girl.change_love(1)
            elif girl.is_("very lewd"):
                girl.char "Ah, now we're talking! I hope you'll show me some new tricks..."
                $ girl.change_love(2)
            elif girl.is_("lewd"):
                girl.char "I see... I'm sure we can learn from one another..."
                $ girl.change_love(1)

        "I'm a sex god":
            $ renpy.block_rollback()
            you "Babe, I'm the best lay in town, believe me."

            # Will she believe you?

            $ res = MC.get_charisma() + dice(6)

            if MC.get_alignment() == "evil":
                $ res += 1
            elif MC.get_alignment() == "good":
                $ res -= 1

            if res >= 8:
                if girl.is_(("repressed", "idealist")):
                    girl.char "Ew, you're disgusting!"
                    $ girl.change_love(-1)
                elif girl.is_(("repressed", "materialist")):
                    girl.char "I wish you didn't mention that... But men are pigs, so I suppose that was to be expected."
                elif girl.is_(("lewd", "materialist")):
                    girl.char "Interesting... I could really make use of your talents..."
                    $ girl.change_love(5)
                elif girl.is_(("lewd", "idealist")):
                    girl.char "Hey, watch out for diseases, you dog... *laugh*"
                    $ girl.change_love(2)

            else:
                if girl.is_("repressed"):
                    girl.char "Haha. You're... You're joking, right?"
                    you "Uh... Sure!"
                    $ girl.change_love(1)
                else:
                    girl.char "Big words, but can you prove it?"

        "I'm a brothel owner, so..." if not girl.MC_lied:
            $ renpy.block_rollback()
            you "Well, I'm a brothel owner, so what do you expect... It's my job!"

            if girl.is_(("repressed", "idealist")):
                girl.char "I know... That was to be expected, I guess... *sigh*"
            elif girl.is_(("repressed", "materialist")):
                girl.char "Don't rub it in my face! It's bad enough that my boyfriend is a pimp, I don't need a reminder."
                $ girl.change_love(-1)
            elif girl.is_(("lewd", "materialist")):
                girl.char "Well, I'm sure you're getting plenty of experience to better satisfy me then..."
                $ girl.change_love(2)
            elif girl.is_(("lewd", "idealist")):
                girl.char "Well, you should always strive to be the best at your job, shouldn't you? *smile*"
                $ girl.change_love(2)
    return
    
label free_flirt_sex_tastes(girl):

    $ MC.rand_say(("What do you like in bed?", "Is there anything you like in the bedroom?", "Tell me what turns you on.", "What is your favorite sexual position?"))

    if dice(6) >= 4: #Describe positive acts and fixations

        $ fix = rand_choice(girl.pos_fixations)
        $ act = rand_choice(fix.acts)

        if girl.personality_unlock[act] and dice(6) >= 4:

            $ renpy.say(girl.char, "You know what fascinates me about %s?" % act_description[act])

            $ text1 = fix_description[fix.name + " description"].lower()

            play sound s_mmmh
            "She tells you that she is interested in [text1]"

            if not girl.personality_unlock[fix.name]:

                "You have discovered [girl.name]'s fixation with [fix.name]."

                $ girl.personality_unlock[fix.name] = True

        else:

            "She blushes as she whispers something to you."

            $ text1 = "Well, I've heard a lot about %s..." % act_description[act]

            $ girl.personality_unlock[act] = True
            $ girl.personality_unlock["LR"] += MC.get_charisma() + 15 + dice(10)
            $ girl.raise_preference(act, "love", 0.5)

            if girl.is_("repressed"):
                girl.char "[text1] Do you think it's wrong?"
            else:
                girl.char "[text1] I think I'd like to try new things."

    else:

        $ fix = rand_choice(girl.neg_fixations)

        if fix:

            $ act = rand_choice(fix.acts)

            if girl.personality_unlock[act] and dice(6) >= 4:
                play sound s_sigh
                $ renpy.say(girl.char, "You know the one thing I really hate about %s?" % act_description[act]) 
                "She tells you that [fix.name] disturbs her. It creeps her out."

                if not girl.personality_unlock[fix.name]:

                    "You have discovered [girl.name]'s disgust for [fix.name]."

                    $ girl.personality_unlock[fix.name] = True

            else:
                $ text1 = "%s makes me uncomfortable..." % act_description[act]

                "She blushes as she whispers something to you."

                $ girl.personality_unlock[act] = True
                $ girl.personality_unlock["LR"] += MC.get_charisma() + 15 + dice(10)

                if girl.is_("repressed"):
                    girl.char "[text1] I think it's dirty."
                else:
                    girl.char "[text1] There's something about it that bothers me."

        else:
            girl.char "I guess I'm comfortable with pretty much anything now."

    $ girl.personality_unlock["LR"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    if girl.is_("very lewd"):
        $ girl.change_love(3)
    elif girl.is_("lewd"):
        $ girl.change_love(2)
    elif not girl.is_("very repressed"):
        $ girl.change_love(1)
    return
    
label free_flirt_sex_act(girl):
    $ act = topic.act
    
    if act == "naked":
        $ girl.personality_unlock["EI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves
        $ MC.rand_say(("Tell me something: do you sleep naked at night?", "Do you like to expose yourself in front of people?", "How do you feel when other people look at you in your natural state?",
                        "ev: Do you like to expose your bare pussy like a horny bitch?", "ne: Do you like to show your body to strangers?", "gd: You have such a perfect body. Do you enjoy people looking at it?", 
                        "ar: Do you agree that since Arios shines His light on everything, hiding your body under clothes is unnecessary?", "wr: Zonian she-warriors fight with nothing but a sword and a cat-tail stuck into their asshole. Would that turn you on?"))

    elif act == "service":
        $ girl.personality_unlock["DS"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves
        $ MC.rand_say(("Do you mast a lot?", "Do you like oral?", "How do you like to go down on guys?", "ar: What do you know about Arios candle worship?", "ev: How would you like to choke on my dick",
            "ne: I'm sure you can use those assets of yours to pleasure a man...", "gd: With a lovely mouth like yours, you must give the best blowjobs...", "tr: In all my travels, I have found that a skilled tongue is the best way to get what you want... It's even more true for pretty babes like you. Do you agree? *wink*"))

    elif act == "sex":
        $ girl.personality_unlock["MI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves
        $ MC.rand_say(("Are you a virgin?", "Ever done it with a man?", "ev: Do you like riding dicks? Come on, a bitch like you should love it.", "ne: Do you like sex, babe?", "gd: How do you like to make sweet love, darling?", "ng: Ever been to heaven with a man?", "wz: Many girls told me I can perform miracles with my magic wand. Would you like me to show you?"))

    elif act == "anal":
        $ girl.personality_unlock["LR"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves
        $ MC.rand_say(("Ever used the back door?", "Do you like it from behind? You know...", "ev: You look like a butt slut. Are you?", "gd: Ever used your other love hole?", "ne: How do you like it up the ass?", 
            "sh: Have you ever done it Shalia's way?", "wr: In war, it's always best to charge from behind. In love, it's the same, wouldn't you say?"))

    elif act == "fetish":
        $ girl.personality_unlock["DS"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves
        $ MC.rand_say(("Do you like kinky sex?", "Do you like to do really naughty things in bed?", "Do you like pleasure mixed with pain?", "Do you own many sex toys?",
                       "ev: Would you like me to hurt you? Say it.", "ne: How far would you go with me? I know a trick or two...", "gd: Do you trust me? I could show you some fun and dirty tricks...",
                       "wz: Some girls like to use magic to spice up their sexual encounters. Should we try it together?"))

    elif act == "bisexual":
        $ girl.personality_unlock["MI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves
        $ MC.rand_say(("Ever done it with another girl?", "Do you like to be with another woman?", "Ever heard of saphism? Did you give it a try?", "tr: In Borgo, fisherwomen like to polish each other's pearls. Do you?",
                        "Are you bisexual?", "Do you like girls?", "ev: It takes a bitch to know one. Ever tried fucking a girl?", "ne: Man, woman, does it matter to you?", "gd: You're lovely and caring, I'm sure women like you too. Don't they?", "sh: Worshipping a goddess is always more satisfactory than a god, wouldn't you say?", 
                        ))

    elif act == "group":
        $ girl.personality_unlock["EI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves
        $ MC.rand_say(("Ever been in an orgy?", "Do you like a threesome?", "gd: The more the merrier, wouldn't you say?", "ev: How many dicks can you take at the same time?", 
                        "Do you like group sex?", "ne: How about fucking several people at once? Does that turn you on?", "ng: Wasting valuable time praying fickle gods is stupid, when you could be having a decadent earthly orgy instead. Don't you agree?", 
                        "wr: The best training a warrior can get is fighting many enemies at once. And since love is like a battlefield..."))

    $ pref = girl.get_preference(act)

    if pref in ("refuses",):
        play sound s_surprise
        "She gives you an innocent look."
        girl.char "Honestly, I have no idea what you're talking about."
    elif pref in ("extremely reluctant", "very reluctant"):
        "She gives you a disgusted look."
        girl.char "I don't know much about that. Let's discuss something else."
    elif pref in ("reluctant", "a little reluctant"):
        "She frowns."
        girl.char "That's not my favourite thing, you know. I know it's popular with some people, but..."

    elif pref in ("indifferent",):
        "She thinks for a moment."
        girl.char "Oh, well... I don't mind it, I guess..."
        $ girl.change_love(1)

    elif pref in ("a little interested", "interested"):
        "She blushes."
        girl.char "Hmmm... Don't talk about this, you'll make me horny..."
        $ girl.change_love(2)

    elif pref in ("very interested", "fascinated"):

        play sound s_mmmh

        "She blushes and licks her lips."
        girl.char "Don't get me started, I love it... It's one of my favorite things."
        $ girl.change_love(3)

    else:
        $ raise AssertionError, ("Reaction not found: " + pref)
    
    return
    
label free_give_gift(girl): # Interactions are deducted here for giving gold
    python:

        available_gifts = []

        for it in MC.items:

            if it.usage == "give":

                available_gifts.append(it)

    python:

        gift_list = []

        for it in available_gifts:

            gift_list.append((it.name, it))

        gift_list.append(("Go back", "back"))

        result = long_menu("Choose a present", gift_list)

    if result == "back":
        return

    $ MC.interactions -= 1
    $ girl.talked_to_date = calendar.time
    $ girl.MC_interact_counters["gift"] += 1
    $ renpy.block_rollback()
    $ MC.gift(girl, result)
    return
    
label free_give_gold(girl): # Interactions are deducted here for giving presents

    if district.rank == 1:
        $ tip_range = (10, 50, 100, 200)

    elif district.rank == 2:
        $ tip_range = (50, 250, 500, 1000)

    elif district.rank == 3:
        $ tip_range = (250, 1000, 2500, 5000)

    else:
        $ tip_range = (500, 2500, 5000, 10000)

    $ modifier = 0

    if girl.personality.name in ("superficial", "cold", "pervert"):

        $ modifier = 10

    elif girl.personality.name in ("rebel", "sweet"):

        $ modifier = -10

    menu:

        you "I want you to have this."

        "[tip_range[0]] gold" if MC.gold >= tip_range[0]:

            $ tip = tip_range[0]

            $ diff = 75

        "[tip_range[1]] gold" if MC.gold >= tip_range[1]:

            $ tip = tip_range[1]

            $ diff = 50

        "[tip_range[2]] gold" if MC.gold >= tip_range[2]:

            $ tip = tip_range[2]

            $ diff = 25

        "[tip_range[3]] gold" if MC.gold >= tip_range[3]:

            $ tip = tip_range[3]

            $ diff = 0

        "Go back":
            $ choice_menu_girl_interact = False
            hide screen dark_filter
            return

    $ MC.gold -= tip

    $ MC.interactions -= 1
    $ girl.talked_to_date = calendar.time
    $ girl.MC_interact_counters["gold"] += 1
    
    $ renpy.block_rollback()
    
    $ result = dice(100) + modifier - diff
    
    $ girl.personality_unlock["MI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves

    play sound s_gold

    if result >= 50:

        girl.char "Oh, this is so much! Thank you from the bottom of my heart... I really needed the money..."

        $ girl.change_love(6, cap=75)

    elif result >= 25:

        girl.char "This is a lot, thank you so much!"

        $ girl.change_love(4, cap=75)

    elif result >= 0:

        girl.char "Thank you, this is a nice gesture."

        $ girl.change_love(2, cap=75)

    elif result >= -25:

        girl.char "Why do you give me that? Do you expect something in return?"

    else:

        girl.char "Giving me money, are you? Do you think I'm a petty whore? *mad*"

        $ girl.change_love(-1)
    return
    
label free_offer_job(girl):

    you "[girl.name], I think I have found a solution to your problem."

    girl.char "What? You have?"

    you "Come and work for me."

    if not girl.MC_lied:

        girl.char "With you? At the brothel?"

        if girl.personality.name in ("superficial", "meek"):

            "She starts to cry."

            girl.char "It sounds scary! I don't want to... Oh, what am I going to do..."

            $ girl.change_love(-5)

            girl.char "Will... Will you take good care of me if I do?"

        elif girl.personality.name in ("nerd", "cold", "sweet"):

            "She looks at you with resolve."

            girl.char "Me? A whore? Isn't there any other way..."

            girl.char "I'm glad you told me the truth about your job. It gave me time to think it over."

            $ girl.change_love(5)

            girl.char "Do you... think I could do it?"

        elif girl.personality.name == "rebel":

            "She gives you a furious look."

            girl.char "Me? A whore? Are you fucking crazy!"

            you "Considering your options, do you really have a choice?"

            girl.char "What the... This is so bad. Will it prevent me from going on trial at least?"

        elif girl.personality.name in ("masochist", "pervert"):

            "She gives you a curious look."

            girl.char "You must think I'm a dirty bitch, don't you?"

            you "Well..."

            girl.char "I'm not saying you're wrong...Mmmh..." 

            "She bites her lips."

            girl.char "If I worked there, I would get fucked by random strangers all day, right?"


    else:

        if girl.MC_lied == "half":

            girl.char "Work for you? I thought you were a freelance [MC.playerclass]?"

            you "Well, this isn't the whole truth... You see, I also have a business on the side."

            girl.char "What... What do you mean?"

            you "Well I, uh, own a cathouse..."

            girl.char "A brothel? You're a brothel owner?"

            if girl in ("masochist", "pervert"):

                girl.char "What the hell!! Couldn't you have told me that before!"

                you "I'm sorry..."

                girl.char "This is way more interesting than I thought... Why did you hide it from me!!! I'm so mad..."

                girl.char "So if I worked there, I would get to have sex with random strangers all day, is that right?"

#                                $ girl.change_love(-5)

            else:

                girl.char "You never told me!"

                $ girl.change_love(-2)

                you "Well, I thought it was unimportant at the time..."

                girl.char "Girls there... They... have sex for money, is that right?"

        else:

            girl.char "Work for you? Oh yes, I forgot, you're [girl.MC_lied]!"

            you "I..."

            girl.char "This is great! We can be together, and I will be safe, get money..."

            you "I'm afraid that it isn't so simple..."

            girl.char "I don't like that look... What do you mean?"

            you "I'm afraid I didn't tell you the truth. I'm not [girl.MC_lied], I'm a pimp. I own a brothel in town."

            if girl.personality.name in ("nerd", "rebel", "sweet", "cold"):

                girl.char "You WHAT?"

                girl.char "You fucking liar!!! How could I have trusted you!!! *cries*"

                $ girl.change_love(-5)

                girl.char "Oh, this is so terrible... All my hopes are crushed... What would I even get from working for you?"

                you "Well, I would protect you, give you lodging and regular pay..."

                girl.char "What should I do... Are you serious?"

            elif girl.personality.name in ("pervert", "masochist"):

                girl.char "Ah, so you were lying the whole time, weren't you! That's clever."

                girl.char "And what a fun job at the same time... I feel so jealous!"

                $ girl.change_love(5)

                girl.char "Will you let me work for you?"

            else:

                girl.char "Oh, so you lied..."

                girl.char "It's not how I was dreaming it would happen... Me, a hooker?"

                you "Well, some girls prefer the term 'escort'..."

                girl.char "Escort? Hmm, got a nice ring to it."

                girl.char "So you're not [girl.MC_lied]. But it's still a good situation, right? I mean..."

    you "Of course. The sex trade is hard work, but it has its perks, you know... Flexible schedule, good money, round-the-clock protection..."

    you "You could also just be a waitress, or a dancer... It's not so bad."

    girl.char "Oh..."

    you "There's one more thing."

    girl.char "What?"

    if MC.get_alignment() == "good":

        $ text1 = "I will treat you well of course, taking good care of you."
        $ modifier = 2

    elif MC.get_alignment() == "neutral":

        $ text1 = "I will treat you fairly, and you have nothing to fear if you play by the rules."
        $ modifier = 0

    elif MC.get_alignment() == "evil":

        $ text1 = "I must also warn you that I'm a harsh master. You have to be ready for anything."
        $ modifier = -4

    you "You would have to sign a temporary slave contract. As you know, only sex slaves are allowed in the city's brothels. [text1]"

    you "So, what do you think?"

    girl.char "..."

    $ result = girl.get_love() + MC.get_charisma() + dice(6) + modifier

    $ renpy.block_rollback()

    if result > 95:

        if girl.personality.name in ("meek", "rebel", "superficial", "sweet"):

            girl.char "Okay, I will do anything you ask. I really have no choice, anyway..."

            girl.char "I'm yours. Take me."

        else:

            girl.char "All right. This is a fair offer. I'll take it!"

        you "It is decided then. Take your things and come with me. I will have you magically branded..."

        "[girl.fullname] has become one of your girls."

        $ girl.love /= 2

        $ acquire_girl(girl, free = True)
        $ selected_location.girls.remove(girl)

    elif result > 90:

        girl.char "Thank you for your offer... But..."

        girl.char "I'm not ready to accept that yet. There must be other options..."

        "She leaves, looking thoughtful."

    else:

        girl.char "Fuck you, that's what I think! Who the hell do you think I am!"

        if girl.MC_lied:

            girl.char "You lied to me, and now you want me to work in your shitty establishment! That's not not gonna happen!"

        else:

            girl.char "Do you think that because I was cool with your job I would make a nice little whore?"

        girl.char "Fuck off!"

        $ girl.change_love(-15)

        "She leaves, looking really mad."

        you "That went well. Maybe later, when she's cooled off?"

    $ girl.MC_lied = False

    $ girl.personality_unlock["MI"] += 10 + MC.get_charisma() + dice(6) # Temp, see how it behaves
    return

    
    
label free_girl_friend(girl):
    
    $ girl.fear -= 5
    
    girl.char "We've known each other for a little while now. Let's be friends!"
            
    you "Okay, sure!"
    
    girl.char "But there's one thing I'd like to know... You never told me about your job. What do you do?"
    
    menu:
        
        "What do you tell her?"
        
        "Tell the truth":
            
            $ renpy.block_rollback()
            
            $ girl.MC_lied = False
            
            you "I own a brothel in town. I'm a pimp."
            
            if girl.personality.name in ("meek", "rebel", "superficial", "sweet"):
                
                $ girl.change_love(-5)
                
                girl.char "This... This is an awful way of life! It's wrong!"
                
                you "Well, it pays the bills... What do you do for a living?"
                
                girl.char "Err, well..."
                
            elif girl.personality.name in ("pervert", "nerd"):
                
                girl.char "Ooh, fascinating!!! You must let me visit one day, I'm so curious! Can I?"
                
                $ girl.change_love(5)
                
                you "Well, sure... What about you, what do you do?"
                
                girl.char "Oh, me? Not much these days..."
                
            else:
                
                girl.char "Is that so? Well, that's as good a job as any, I suppose..."
                
                you "And what is it you do?"
                
                girl.char "..."
        
        
        "Tell a half lie":
            
            $ renpy.block_rollback()
            
            $ girl.MC_lied = "half"
            
            you "Well, er, I'm a [MC.playerclass] freshly arrived in Zan. I'm considering a career change though..."
            
            if girl.personality.name in ("rebel", "sweet"):
                
                girl.char "A [MC.playerclass]? Oh, this is awesome! You should teach me some tricks!"
                
                $ girl.change_love(2)
                
                you "Well, sure... What about you, what do you do?" 
                
                girl.char "Well, just like you... I'm between jobs..."
                
                "Her mood darkens a bit."
            
            else:
                
                girl.char "Oh, I see. Lots of adventurers around these days."
                
                you "And what is it you do?"
                
                girl.char "Me? Oh, ahem..."
                            
            
        "Outright lying":
            
            $ renpy.block_rollback()
        
            $ lie = rand_choice(("a secret guild master", "an expert weaponsmith", "a professional circus athlete", "an Arios knight", "a famous No actor"))
        
            $ girl.MC_lied = lie
            
            you "Me? Uh, I'm..."
            
            you "I'm {b}[lie]{/b}!"
            
            if girl.personality.name in ("nerd", "cold"):
                
                girl.char "Is that so? Strange. I've never heard of you. Are you telling me the truth?"
                
                $ girl.change_love(-5)
                
                you "Well, uh... Oh, look at the time, haha! I really need to go."
                
            elif girl.personality.name in ("superficial", "meek"):
                
                girl.char "Really? This is so awesome! It is a good job, isn't it?"
                
                $ girl.change_love(5)
                
                you "Yeah, sure..."
                
                girl.char "Oh, maybe you'll need help someday... You could hire me..."
                
            else:
                
                girl.char "A... [lie]? I see."
                
                you "Haha! And you, what is it you do?"
                
                girl.char "Oh, you know, this and that..."                
    
    
    $ girl.MC_relationship_level = 1
    $ girl.track_event("MC friend", arg=girl.name)
    
    with fade
    
    "You and [girl.fullname] are now friends."

    return
    
    
label free_girl_love_interest(girl):
    
    $ girl.fear -= 5

    girl.char "Oh, it's you..."
            
    you "Hi, [girl.name]. Is something wrong?"
    
    $ season = calendar.get_season()
    
    girl.char "Uh, me? No... I was just looking at the couples kissing and holding hands on this beautiful [season] day..."
    
    girl.char "Ah, I feel lonely now..."
    
    girl.char "Did you know... Boys bring girls flowers to tell them they like them. It's a nice gesture..."
    
    you "Is that so?"
    
    "She looks at you with some intensity, then turns her head away."
    
    girl.char "Anyway. Let's get out of here."
    
    with fade
    
    "You may now bring [girl.fullname] {b}flowers{/b} to express your interest."
    
    $ girl.MC_relationship_level = 2
    $ girl.track_event("MC flower", arg=girl.name)
    
    return
    
    
label free_girl_girlfriend(girl):
    
    $ girl.fear -= 5
    
    girl.char "Oh, [MC.name]! Come here, sweetheart..."
    
    you "Hi, love. How are you today?"
    
    girl.char "I'm fine, darling... Come with me, I wanna show you something..."
    
    you "Why, sure..."
    
    girl.char "But first, I wanna ask you a question."
    
    $ passed = False
    
    $ d = dice(6)
    
    if d >= 5:
        
        girl.char "Do you remember my hobby?"
        
        python:
        
            hobby_list = []
            
            hobby_list.append(rand_choice(girl.hobbies))
            
            for i in range(4):
                
                h = rand_choice(hobbies)
                
                while h in hobby_list:
                    
                    h = rand_choice(hobbies)
                
                hobby_list.append(h)
                
            renpy.random.shuffle(hobby_list)
            
            m = []
            
            m.append(("[girl.name]'s hobby is...", None))
            
            for h in hobby_list:
                
                m.append((h, h))
                
            m.append(("I don't know", "give up"))
            
            r = menu(items = m)
            
        $ renpy.block_rollback()
            
        if r in girl.hobbies:
            
            girl.char "You're right, of course! Come with me."
            
            $ passed = True
        
        elif r == "give up":
            
            you "I just don't know. Sorry."
            
            girl.char "Oh, really? I guess we don't know each other so well, after all... *frown*"
            
            $ girl.change_love(-5)
            
        else:
            
            girl.char "You're awful!!! It's not that at all!!! What terrible boyfriend you are... *mad*"
            
            $ girl.change_love(-10)
            
            you "Ah, uh, sorry..."
            
    elif d >= 4:
        
        girl.char "Do you remember where I come from?"
        
        python:
        
            origin_list = []
            
            origin_list.append(girl.origin)
            
            for i in range(3):
                
                h = rand_choice(origins)
                
                while h in origin_list:
                    
                    h = rand_choice(origins)
                
                origin_list.append(h)
                
            renpy.random.shuffle(origin_list)
            
            m = []
            
            m.append(("[girl.name] comes from...", None))
            
            for h in origin_list:
                
                m.append((h, h))
                
            m.append(("I don't know", "give up"))
            
            r = menu(items = m)
        
        $ renpy.block_rollback()
        
        if r == girl.origin:
            
            girl.char "You're right, of course! Come with me."
            
            $ passed = True
        
        elif r == "give up":
            
            you "I just don't know. Sorry."
            
            girl.char "Oh, really? I guess we don't know each other so well, after all... *frown*"
            
            $ girl.change_love(-5)
            
        else:
            
            girl.char "You're awful!!! I don't come from this place at all!!! You're thinking of some other girl aren't you? *mad*"
            
            $ girl.change_love(-10)
            
            you "Ah, uh, sorry..."
        
    else:
        
        $ thing = rand_choice(("color", "food", "drink"))
        
        if dice(6) >= 4:
            
            $ type = "favorite"
            
        else:
            
            $ type = "least favorite"
                
        girl.char "Do you remember what is my [type] [thing]?"
        
        python:
        
            fav_list = []
            
            if type == "favorite":
            
                fav_list.append(girl.likes[thing])
                
            else:
                
                fav_list.append(girl.dislikes[thing])
            
            if thing == "color":
                
                base = colors
                
            elif thing == "food":
                
                base = food
                
            elif thing == "drink":
                
                base = drinks
            
            for i in range(3):
                
                h = rand_choice(base)
                
                while h in fav_list:
                    
                    h = rand_choice(base)
                
                fav_list.append(h)
                
            renpy.random.shuffle(fav_list)
            
            m = []
            
            m.append(("[girl.name]'s [type] [thing] is...", None))
            
            for h in fav_list:
                
                m.append((h, h))
                
            m.append(("I don't know", "give up"))
            
            r = menu(items = m)
            
        $ renpy.block_rollback()
        
        if (type == "favorite" and r == girl.likes[thing]) or (type == "least favorite" and r == girl.dislikes[thing]):
            
            girl.char "You're right, of course! Come with me."
            
            $ passed = True
        
        elif r == "give up":
            
            you "I just don't know. Sorry."
            
            girl.char "Oh, really? I guess we don't know each other so well, after all... *frown*"
            
            $ girl.change_love(-5)
            
        else:
            
            girl.char "Whaat? No! You're awful!!! You don't know me at all... *mad*"
                            
            $ girl.change_love(-10)
            
            you "Ah, uh, sorry..."
            
            
    if passed:
        
        "She leans closer to you."
        
        girl.char "Don't you think... We need to know each other better?"
        
        $ pic = girl.get_pic("profile", and_tags="naked", soft=True)
        
        show screen show_sex_event(pic, bg=loc_pic)
        
        with fade
        
        "Dropping her clothes to the ground, she looks deep into your eyes."
        
        $ girl.raise_preference("naked", "love", 1)
        
        if girl.get_effect("special", "naked"):
            girl.char "Don't you think being comfortable with our body is a wonderful feeling?"
            
            "You gulp as she cups her boobs in her hands and give them a little jiggling."
            
            girl.char "I always feel very comfortable when I'm naked around the house... I wish I could be naked all the time!"
            
            play sound s_sigh
            
            girl.char "But I'm not going around the town naked, of course... I'm not crazy."
            
            play sound s_laugh
            girl.char "Still, I'm happy I could show you my true self... You look happy too! *giggle*"
            
        else:
            girl.char "Do you like what you see?"

            "You can feel your dick become harder by the second. She seems to notice it, and smiles back at you."
            
            play sound s_mmmh
            girl.char "Mmmh..."

        hide screen show_sex_event

        with fade
        
        "You may now have extra 'fun' with [girl.fullname]."
        
        $ girl.MC_relationship_level = 4
        $ girl.track_event("MC lover", arg=girl.name)
        
    else:
            
        you "Anyway... What was it you wanted to show me?"
        
        girl.char "Never mind... It doesn't matter."
            
    return
    

label free_girl_job_request(girl):
    $ girl.fear -= 5
    
    "[girl.name] comes to you with a panicked look in her eyes."
            
    if girl.personality.name == "meek":
        
        girl.char "Oh, [MC.name], this is so awful... *sob*"
        
        you "Baby what's going on?"
        
        girl.char "The guard... They evicted us from the house... And mother... She's sick... My brothers told me they couldn't have another mouth to feed..."
        
        girl.char "I'm all alone now. Surely I'll die of starvation, or I'll get captured by ruffians who will rape and kill me!"
        
        "She bursts into tears."
        
        you "[girl.name] calm down, we'll find a solution..."
        
    elif girl.personality.name == "nerd":
        
        girl.char "Oh, [MC.name]. You wouldn't happen to know of a quick and efficient way to make money, would you?"
        
        you "Well, I just might... What's going on?"
        
        girl.char "It's the school. I have to pay the tuitions somehow so I can keep studying there, but all my savings are gone now." 
        
        girl.char "If I don't find a way to make money quickly, I will drop out and loose my chance to get an education..."
        
        "She looks worried."
        
        you "There might be a way... Flexible hours, and all. You probably won't like it, though."
        
        girl.char "Come on, I'd do anything to keep studying. This is very important to me."
        
    elif girl.personality.name == "pervert":
        
        girl.char "This is a disaster! The Jolly Paladins are leaving!"
        
        you "The... The what??"
        
        girl.char "The Jolly Paladins! Don't you know them? They're a wizzball team famous all over Xeros!"
        
        you "And..."
        
        girl.char "And? And I was their girl!!! I used to date the team captain, and his second, and... They lavished me with gifts and attention..."
        
        you "Well, I..."
        
        girl.char "Sorry, honey, you're great, but a girl's gotta have her fun... A wizzball team is 23 players!!! Where am I gonna find another batch of rich, horny men???"
        
        you "Mmmh..."
        
        $ girl.change_preference("group", 250)
        
    elif girl.personality.name == "rebel":
        
        girl.char "[MC.name]... Help me, please!"
        
        you "Asking for help? That doesn't sound like you..."
        
        girl.char "I... I iced this guy a few weeks back... He was trying to rape me. I will be put on trial in a few days... They'll... They'll enslave me!"
        
        "In Zan, a judge can make you a slave if you don't have money to pay for your crime..."
        
        girl.char "I used the last of my money to pay bail... They'll find me guilty, and the man's brother will enslave me! They'll rape and torture me for the rest of my life!"
        
        girl.char "Tens of thousand of denars... There's no way out... If only I could somehow escape this trial..."
        
        you "Mmmh... Did you know that slaves cannot be put on trial? Only their masters?"
        
        girl.char "But I'm not a slave... What are you suggesting?"
                   
    elif girl.personality.name == "superficial":
        
        girl.char "Oh, [MC.name]! Why does everyone tries to make my life so terrible!"
        
        you "Come on, honey, that's not true... What's going on?"
        
        girl.char "It's my dad! His estate... Since he passed away... I only used it for a few expenses, a few handbags, half a dozen dresses, magical lingerie..."
        
        girl.char "But the stupid clerk said the money is gone! All gone! And now the greedy loansharks I borrowed some petty money from want it back *cry*"
        
        "She looks at you with tearful eyes."
        
        girl.char "I am so deeply in debt! What am I gonna do... *sob*"
        
        you "Mmmh... Well, there's one way maybe... Slaves cannot own debt, you know?"
             
        girl.char "Uh?"
        
    elif girl.personality.name == "cold":
        
        girl.char "Hi, [MC.name]."
        
        you "Hi, [girl.name]."
        
        girl.char "Can I work for you?"
        
        you "Uh?"
        
        girl.char "I said, can I work for you? I need the money. How hard can it be, anyway?"
        
        you "Well... That's an unexpected request... Let me think about it."
        
    elif girl.personality.name == "masochist":
        
        girl.char "..."
        
        you "Yes, [girl.name]?"
        
        girl.char "I'm worthless."
        
        you "Uh???"
        
        girl.char "I'm a worthless piece of shit. I want you to hurt me. I want to be used like a toilet. I want..."
        
        you "Wow, we've had some kinky moments, but... This is new."
        
        girl.char "Help me. Put me on my knees. Hit me. I want to be a slave..."
        
        you "You do now, do you..."
        
    elif girl.personality.name == "sweet":
        
        girl.char "Are you... Are you seeing other girls?"
        
        you "Uh?"
        
        girl.char "Tell me the truth... Oh, I know... I've seen you with them... It feels like my heart will burst!"
        
        you "I'm sorry... I... I will explain..."
        
        girl.char "It's okay. You don't have to love me, but I love you. I want to be near you always."
        
        girl.char "I'll do anything to stay by your side. I'll become your slave, even, if you want me to."
        
        girl.char "Will... Will you have me? I beg you, please take me... I'm yours!"
        
        you "Well... I'll... Let me think..."
        
    
    $ girl.MC_relationship_level = 5
    $ girl.track_event("MC job", girl.name)
    
    "You can now offer [girl.fullname] a job."
    
    return

label free_try_interact(girl, group):
                            
    if not can_interact(girl, group, slave=False):
                                
        if group == "gold":
            "You can only give a girl money once per day."
            
        elif group == "present":
            "You can only give a girl one present per day."
            
        elif group == "offer":
            if len(MC.girls) >= brothel.bedrooms:
                "You cannot offer her work as long as your brothel is full."
                    
            elif girl.MC_interact_counters[group] >= 1:                
                "You cannot offer her work again today."
                
        else:
            "You cannot do the same action with a girl more than 3 times a day."
                                
        $ choice_menu_girl_interact = False
            
        hide screen dark_filter
            
        jump free_girl_interact_menu
            
    $ renpy.block_rollback()
                                
    if group not in ("gold", "gift"): # Counters for giving gold and presents are handled in their own label
        $ girl.MC_interact_counters[group] += 1
        $ girl.talked_to_date = calendar.time
        $ MC.interactions -= 1
    
    return
    